Module javafx.controls
Package javafx.scene.control.skin

## Class TableViewSkinBase<M,​S,​C extends Control,​I extends IndexedCell<M>,​TC extends TableColumnBase<S,​?>>

- java.lang.Object
- - javafx.scene.control.SkinBase<C>
  - - javafx.scene.control.skin.VirtualContainerBase<C,​I>
    - - javafx.scene.control.skin.TableViewSkinBase<M,​S,​C,​I,​TC>

- Type Parameters:
    `M` - The type of the item stored in each row (for TableView, this is the type of the items list, and for TreeTableView, this is the type of the TreeItem).
    `S` - The type of the item, as represented by the selection model (for TableView, this is, again, the type of the items list, and for TreeTableView, this is TreeItem typed to the same type as M).
    `C` - The type of the virtualised control (e.g TableView, TreeTableView)
    `I` - The type of cell used by this virtualised control (e.g. TableRow, TreeTableRow)
    `TC` - The type of TableColumnBase used by this virtualised control (e.g. TableColumn, TreeTableColumn)
  All Implemented Interfaces:
    `Skin<C>`
  Direct Known Subclasses:
    `TableViewSkin`, `TreeTableViewSkin`

      public abstract class TableViewSkinBase<M,​S,​C extends Control,​I extends IndexedCell<M>,​TC extends TableColumnBase<S,​?>>
      extends VirtualContainerBase<C,​I>

  TableViewSkinBase is the base skin class used by controls such as `TableView` and `TreeTableView` (the concrete classes are `TableViewSkin` and `TreeTableViewSkin`, respectively).
  Since:
    9
  See Also:
    `TableView`, `TreeTableView`, `TableViewSkin`, `TreeTableViewSkin`

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `TableViewSkinBase​(C control)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected double` | `computePrefHeight​(double width, double topInset, double rightInset, double bottomInset, double leftInset)` | Calculates the preferred height of this `SkinBase`.
    `protected double` | `computePrefWidth​(double height, double topInset, double rightInset, double bottomInset, double leftInset)` | Calculates the preferred width of this `SkinBase`.
    `protected TableHeaderRow` | `createTableHeaderRow()` | Creates a new TableHeaderRow instance.
    `void` | `dispose()` | Called by a Skinnable when the Skin is replaced on the Skinnable.
    `protected void` | `layoutChildren​(double x, double y, double w, double h)` | Called during the layout pass of the scenegraph.
    `protected Object` | `queryAccessibleAttribute​(AccessibleAttribute attribute, Object... parameters)` | This method is called by the assistive technology to request the value for an attribute.
    `protected void` | `updateItemCount()` | This method is called when it is possible that the item count has changed (i.e.

    - ### Methods inherited from class javafx.scene.control.skin.VirtualContainerBase

      `createVirtualFlow, getItemCount, getVirtualFlow, markItemCountDirty`

    - ### Methods inherited from class javafx.scene.control.SkinBase

      `computeBaselineOffset, computeMaxHeight, computeMaxWidth, computeMinHeight, computeMinWidth, consumeMouseEvents, executeAccessibleAction, getChildren, getClassCssMetaData, getCssMetaData, getNode, getSkinnable, layoutInArea, layoutInArea, layoutInArea, positionInArea, positionInArea, pseudoClassStateChanged, registerChangeListener, snappedBottomInset, snappedLeftInset, snappedRightInset, snappedTopInset, snapPosition, snapPositionX, snapPositionY, snapSize, snapSizeX, snapSizeY, snapSpace, snapSpaceX, snapSpaceY, unregisterChangeListeners`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TableViewSkinBase

          public TableViewSkinBase​(C control)

      Parameters:
        `control` - the control

  - ### Method Detail

    - #### dispose

          public void dispose()

      Called by a Skinnable when the Skin is replaced on the Skinnable. This method allows a Skin to implement any logic necessary to clean up itself after the Skin is no longer needed. It may be used to release native resources. The methods `Skin.getSkinnable()` and `Skin.getNode()` should return null following a call to dispose. Calling dispose twice has no effect.
      Specified by:
        `dispose` in interface `Skin<M>`
      Overrides:
        `dispose` in class `SkinBase<C extends Control>`

    - #### computePrefHeight

          protected double computePrefHeight​(double width,
                                             double topInset,
                                             double rightInset,
                                             double bottomInset,
                                             double leftInset)

      Calculates the preferred height of this `SkinBase`. The default implementation calculates this height as the height of the area occupied by its managed children when they are positioned at their current positions at their preferred heights.
      Overrides:
        `computePrefHeight` in class `SkinBase<C extends Control>`
      Parameters:
        `width` - the width that should be used if preferred height depends on it
        `topInset` - the pixel snapped top inset
        `rightInset` - the pixel snapped right inset
        `bottomInset` - the pixel snapped bottom inset
        `leftInset` - the pixel snapped left inset
      Returns:
        the calculated preferred height

    - #### computePrefWidth

          protected double computePrefWidth​(double height,
                                            double topInset,
                                            double rightInset,
                                            double bottomInset,
                                            double leftInset)

      Calculates the preferred width of this `SkinBase`. The default implementation calculates this width as the width of the area occupied by its managed children when they are positioned at their current positions at their preferred widths.
      Overrides:
        `computePrefWidth` in class `SkinBase<C extends Control>`
      Parameters:
        `height` - the height that should be used if preferred width depends on it
        `topInset` - the pixel snapped top inset
        `rightInset` - the pixel snapped right inset
        `bottomInset` - the pixel snapped bottom inset
        `leftInset` - the pixel snapped left inset
      Returns:
        the calculated preferred width

    - #### layoutChildren

          protected void layoutChildren​(double x,
                                        double y,
                                        double w,
                                        double h)

      Called during the layout pass of the scenegraph.
      Overrides:
        `layoutChildren` in class `VirtualContainerBase<C extends Control,​I extends IndexedCell<M>>`
      Parameters:
        `x` - the x position
        `y` - the y position
        `w` - the width
        `h` - the height

    - #### createTableHeaderRow

          protected TableHeaderRow createTableHeaderRow()

      Creates a new TableHeaderRow instance. By default this method should not be overridden, but in some circumstances it makes sense (e.g. testing, or when extreme customization is desired).
      Returns:
        A new TableHeaderRow instance.

    - #### updateItemCount

          protected void updateItemCount()

      This method is called when it is possible that the item count has changed (i.e. scrolling has occurred, the control has resized, etc). This method should recalculate the item count and store that for future use by the `VirtualContainerBase.getItemCount()` method.
      Specified by:
        `updateItemCount` in class `VirtualContainerBase<C extends Control,​I extends IndexedCell<M>>`

    - #### queryAccessibleAttribute

          protected Object queryAccessibleAttribute​(AccessibleAttribute attribute,
                                                    Object... parameters)

      This method is called by the assistive technology to request the value for an attribute.

      This method is commonly overridden by subclasses to implement attributes that are required for a specific role.
      If a particular attribute is not handled, the superclass implementation must be called.

      Overrides:
        `queryAccessibleAttribute` in class `SkinBase<C extends Control>`
      Parameters:
        `attribute` - the requested attribute
        `parameters` - optional list of parameters
      Returns:
        the value for the requested attribute
      See Also:
        `AccessibleAttribute`, `Node.queryAccessibleAttribute(javafx.scene.AccessibleAttribute, java.lang.Object...)`